# Help
The MIDI 2.0 Workbench is a tool to aid in the testing and development of MIDI 2.0 Devices. 

As new MIDI 2.0 Devices are released into the market it is important to make sure that these each MIDI 2.0 Device works
according to MIDI 2.0 Specifications. For consumers this leads to better interoperability between Devices. For 
Manufacturers this means improved Workflow and testing during Development.

The MIDI 2.0 Workbench achieves this by connecting to a UMP or MIDI-CI enabled MIDI Devices and providing tools, checklists 
and debugging to verify the Device is working as defined by MIDI specifications. Current MIDI 2.0 Specifications can be 
found on [https://midi.org/specs](https://midi.org/specs)

### Basic Overview:
<iframe width="560" height="315" src="https://www.youtube-nocookie.com/embed/43duptJN4uw" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>

### MIDI 2.0 Workbench: How Do I
* [[Set-up the Workbench?|config]]
* [[Debug my Device?|debug]]
* [[Report an Error in the Workbench?|report]]
* [[Set Up and Test a MIDI 1.0 Device using MIDI-CI|testM1MidiCi]]
* [[Test a UMP Device?|testUMPDevice]]
  * [[Test Windows API|win2midi]]
  * [[Setup a USB UMP Device?|usb]]
* [[Test a MIDI-CI Device in Function Block on a UMP Device?|testFuncBlock]]
* [[Fill out a Logo Implementation CheckList?|logoChecklist]]
