# Logo Implementation CheckList

The Logo Implementation Checklist is available when [[testing a UMP device|testUMPDevice]] 
and [[testing a MIDI 1.0 Device using MIDI-CI|testM1MidiCi]]. 

### Before you start
MIDI 2.0 Logo Implementation CheckList is a quick and simple way to certify your product is MIDI 2.0 compliant. Logo Implementation CheckList 
is the first step to authorising the use of the MIDI 2.0 logo on your product. Each product is certified individually.

Once Logo Implementation CheckList is completed and is sent to the MIDI Association, a Licence agreement will be returned to you 
for the Self Certified product.

Before you start certification please make sure you have the following:

Current MIDI Association or AMEI membership
SysEx Id, Family Id and Model Id in use for the product - Certification will match the Id's of the Product. If the Id's
change a new Logo Implementation CheckList is required.
Designated Person - A representative who has the rights to perform Logo Implementation CheckList and can be contacted if required.

----

### Certification Steps

##### Step 1 Fill out Logo Implementation CheckList form in MIDI 2.0 Workbench
Use the form below.

##### Step 2 Send in the Logo Implementation CheckList PDF
Download the Logo Implementation CheckList PDF from MIDI 2.0 Workbench and send a copy to info@midi.org.

##### Step 3 Await the License Agreement
The Logo Implementation CheckList is processed and a License Agreement will be returned acknowledging your product has been Self 
Certified. This may take a few days.

##### Step 4 Sign the agreement and return
Please sign the MIDI 2.0 Licence agreement and send to info@midi.org.
After signing and returning the agreement you are authorised to use the MIDI 2.0 Logo for that product.

##### Step 5 Inform TMA when the Product is released
The product will then be added to the list of MIDI 2.0 products on [https://midi.org](https://midi.org).

----
### Frequently Asked Question

##### I wish to keep my product "under wraps", but I still need MIDI 2.0 Logo authorisations for printing etc. What happens then?
The only required identifiable information about your product is the SysEx Id, Family Id and Model Id. Other information 
is optional.

The Logo Implementation CheckList questionnaire also has an embargo date, and all information is kept confidential until this date.

##### I have cancelled or postponed the release of my product, can I cancel the Logo Implementation CheckList?
Yes. Please contact info@midi.org with the SysEx Id, Family Id and Model Id.

##### My product has been released, what happens now?
The MIDI Association is excited for your release too! The MIDI Association will add your product to the list of MIDI 2.0 
Products on the [https://midi.org](https://midi.org) website. If the product Logo Implementation CheckList has been completed with 
limited information please get in touch so the product can be listed concisely.